src/tv_aficionado/urls.py
from django.contrib import admin
from django.urls import path, include

from tv_series import urls as tv_series_urls

urlpatterns = [
    path('admin/', admin.site.urls),
    path('tv-series/', include(tv_series_urls)),
]

src/tv_series/urls.py
from django.urls import path

from tv_series import views

urlpatterns = [
    path('', views.home_page, name='home_page'),
    path('add/', views.add_tv_series, name="add_tv_series"),
    path('new', views.new_tv_series, name="new_tv_series"),
    path('<int:tv_series_id>/', views.view_tv_series, name='view_tv_series'),
    path('<str:tv_series_name_year>/', views.view_tv_series_name_year, name='view_tv_series_name_year'),
    path('all/update', views.update_all_tv_series, name='update_all_tv_series'),
]

src/tv_series/models.py
from django.db import models

class TVSeries(models.Model):
    name = models.TextField(default='')
    release_year = models.IntegerField()
    tvdb_id = models.IntegerField()

src/tv_series/views.py
from django.shortcuts import render, redirect

from tv_series.models import TVSeries

def home_page(request):
    tv_series = TVSeries.objects.all()
    return render(request, 'tv-series/home.html', {'tv_series': tv_series})

def add_tv_series(request):
    # Get the TV series parameters from the GET request, if any are passed.
    name = request.GET.get('name', '').replace('-',' ')
    release_year = request.GET.get('release_year', '')
    tvdb_id = request.GET.get('tvdb_id', '')
    status_code = request.GET.get('status', '')
    
    # Form the response based on the status_code
    if status_code == "add-success":
        # The TV series has been successfully added.
        # Pass a notification and do not pass the other arguments.
        status_message = name + ' (' + release_year + ') has been successfully added.'
        return render(request, 'tv-series/add.html', {'status_message': status_message})
    if status_code == "add-fail-missing-name":
        # User did not enter the name.
        # Pass a notification together with the other arguments.
        status_message = 'Please enter the name of the TV series.'
        return render(request, 'tv-series/add.html', {'release_year': release_year, 'tvdb_id': tvdb_id, 'status_message': status_message})
    if status_code == "add-fail-missing-year":
        # User did not enter the release year.
        # Pass a notification together with the other arguments.
        status_message = 'Please enter the release year of the TV series.'
        return render(request, 'tv-series/add.html', {'name': name, 'tvdb_id': tvdb_id, 'status_message': status_message})
    if status_code == "add-fail-missing-tvdb-id":
        # User did not enter the TVDB id.
        # Pass a notification together with the other arguments.
        status_message = 'Please enter the TVDB id of the TV series.'
        return render(request, 'tv-series/add.html', {'name': name, 'release_year': release_year, 'status_message': status_message})
    if status_code == "add-fail-tv-series-exists":
        # User entered a TV series that already exists.
        # Pass a notification and do not pass the other arguments.
        status_message = name + ' (' + release_year + ') already exists.'
        return render(request, 'tv-series/add.html', {'status_message': status_message})

    # Default exist in case the status_code is not covered.
    status_message = ''
    return render(request, 'tv-series/add.html', {'name': name, 'release_year': release_year, 'tvdb_id': tvdb_id, 'status_message': status_message})

def new_tv_series(request):
    # Get the values passed with the POST request
    tv_series_name = request.POST['name']
    tv_series_redirect_name = tv_series_name.replace(' ','-')
    tv_series_release_year = request.POST['release_year']
    tv_series_tvdb_id = request.POST['tvdb_id']

    # Validate the values, all are required and cannot be empty.
    if tv_series_name == "":
        return redirect(f'/tv-series/add/?name={tv_series_redirect_name}&release_year={tv_series_release_year}&tvdb_id={tv_series_tvdb_id}&status=add-fail-missing-name')
    if tv_series_release_year == "":
        return redirect(f'/tv-series/add/?name={tv_series_redirect_name}&release_year={tv_series_release_year}&tvdb_id={tv_series_tvdb_id}&status=add-fail-missing-year')
    if tv_series_tvdb_id == "":
        return redirect(f'/tv-series/add/?name={tv_series_redirect_name}&release_year={tv_series_release_year}&tvdb_id={tv_series_tvdb_id}&status=add-fail-missing-tvdb-id')

    # Check if the entry already exists, the combination of name and release year must be unique. Of course, the tvdb id also must be unique
    if (TVSeries.objects.filter(name__iexact=tv_series_name, release_year__exact=tv_series_release_year).count() != 0 or 
        TVSeries.objects.filter(tvdb_id__exact=tv_series_tvdb_id).count() != 0):
        return redirect(f'/tv-series/add/?name={tv_series_redirect_name}&release_year={tv_series_release_year}&tvdb_id={tv_series_tvdb_id}&status=add-fail-tv-series-exists')

    # Validations passed, data are fine and unique. Create an object.
    TVSeries.objects.create(name=tv_series_name, release_year=tv_series_release_year, tvdb_id=tv_series_tvdb_id)

    # Redirect back to the page passing all the data with the success status message   
    return redirect(f'/tv-series/add/?name={tv_series_redirect_name}&release_year={tv_series_release_year}&tvdb_id={tv_series_tvdb_id}&status=add-success')

def view_tv_series(request, tv_series_id):
    tv_series = TVSeries.objects.get(pk=tv_series_id)
    return render(request, 'tv-series/view.html', {'tv_series': tv_series})

#def view_tv_series(request, tv_series_id):
#    tv_series = TVSeries.objects.get(pk=tv_series_id)
#    return render(request, 'tv-series/view.html', {'tv_series': tv_series})

def view_tv_series_name_year(request, tv_series_name_year):
    # Split the string into words by '-' as the separator
    name_in_words_and_year = tv_series_name_year.split('-')
    
    # Get the release year as the last word after the split
    release_year = name_in_words_and_year[-1]
    
    # Concatinate the name based on the remaining words
    name = name_in_words_and_year[0]
    for cnt in range(1, len(name_in_words_and_year)-1):
        name += " " + name_in_words_and_year[cnt]

    # Find the TV series with the given name and release year
    tv_series = TVSeries.objects.get(name=name, release_year=release_year)

    return view_tv_series(request, tv_series.id)
    
def update_all_tv_series(request):
    return redirect('/tv-series/')

src/tv_series/templates/tv-series/add.html
<html>

<head>
    <title>TV Aficionado</title>
</head>

<body>
    <h1>Add TV Series</h1>
    <form method="POST" action="../new">
        <table id="id_tv_series_info_table">
            <tr>
                <td>Name:</td>
                <td><input name="name" id="id_name" placeholder="Enter the name of a new TV series" value="{{name}}" /></td>
            </tr>
            <tr>
                <td>Release year:</td>
                <td><input name="release_year" id="id_year" placeholder="Enter the release year of the new TV series" value="{{release_year}}" /></td>
            <tr>
                <td>theTVDB id:</td>
                <td><input name="tvdb_id" id="id_tvdb" placeholder="Enter the unique theTVDB ID of the new TV series" value="{{tvdb_id}}" /></td>
            </tr>
        </table>
        <input type="submit" id="id_submit" value="Add">
        {% csrf_token %}
    </form>
    <p id="id_status_message">{{status_message}}</p>
    <a id="id_link_to_home_page" href="../">Back to Home Page</a>
</body>

</html>

src/tv_series/templates/tv-series/home.html
<!DOCTYPE html>
<html>

<head>
    <title>TV Aficionado</title>
</head>

<body>
    <h1>TV Series</h1>
    <table id="id_tvseries_table">
        <tr>
            <td>TV Series</td>
            <td>Last Episode Number</td>
            <td>Last Episode Air Date</td>
            <td>Next Episode Number</td>
            <td>Next Episode Air Date</td>
        </tr>
        {% for tv_series in tv_series %}
        <tr>
            <td><a href="{{tv_series.id}}/">{{tv_series.name}} ({{tv_series.release_year}})</a></td>
            <td></td>
            <td></td>
            <td></td>
            <td></td>
        </tr>
        {% endfor %}
    </table>
    <form method="POST" action="all/update">
        <input type="submit" id="id_update_all" value="Update All">
        {% csrf_token %}
    </form>
    <a id="id_add_tv_series" href="add/">Add new TV series</a>
</body>

</html>

src/tv_series/templates/tv-series/view.html
<html>

<head>
    <title>{{tv_series.name}} ({{tv_series.release_year}})</title>
</head>

<body>
    <h1>{{tv_series.name}} ({{tv_series.release_year}})</h1>
    <table id="id_tv_series_info_table">
        <tr>
            <td>ID:</td>
            <td id="id_tvseries_id">{{tv_series.id}}</td>
        </tr>
        <tr>
            <td>Name:</td>
            <td>{{tv_series.name}}</td>
        </tr>
        <tr>
            <td>Release year:</td>
            <td>{{tv_series.release_year}}</td>
        <tr>
            <td>theTVDB id:</td>
            <td>{{tv_series.tvdb_id}}</td>
        </tr>
    </table>
    <a id="id_link_to_home_page" href="../">Back to Home Page</a>
</body>

</html>